#################### 種族 ####################
use strict;
use utf8;

package data;

## ●種族リスト
 # ['ソート順' , '名前' , '種族特徴' , '6Lv追加特徴' ,'11Lv追加特徴' ,'16Lv追加特徴']
our @races = (
  ['0001', '人間', '［剣の加護／運命変転］'],
  ['0002', 'エルフ', '［暗視］［剣の加護／優しき水］'],
  ['0003', 'ドワーフ', '［暗視］［剣の加護／炎身］'],
  ['0004', 'タビット', '［第六感］'],
  ['0005', 'ルーンフォーク', '［暗視］［HP変換］'],
  ['0006', 'ナイトメア（人間）', '［異貌］［弱点／土］'],
  ['0006', 'ナイトメア（エルフ）', '［異貌］［弱点／水・氷］'],
  ['0006', 'ナイトメア（ドワーフ）', '［異貌］［弱点／炎］'],
  ['0006', 'ナイトメア（リルドラケン）', '［異貌］［弱点／風］'],
  ['0007', 'リカント', '［暗視(獣変貌)］［獣変貌］'],
  ['0008', 'リルドラケン', '［鱗の皮膚］［尻尾が武器］［剣の加護／風の翼］'],
  ['0009', 'グラスランナー', '［マナ不干渉］［虫や植物との意思疎通］'],
  ['0010', 'メリア', '［繁茂する生命］'],
  ['0011', 'ティエンス', '［通じ合う意識］'],
  ['0012', 'レプラカーン', '［暗視］［見えざる手］［姿なき職人］'],
  ['0013', 'アルヴ', '［暗視］［吸精］'],
  ['0014', 'シャドウ', '［暗視］［月光の守り］'],
  ['0015', 'ソレイユ', '［輝く肉体］［太陽の再生］［太陽の子］'],
  ['0016', 'ウィークリング（ガルーダ）', '［蛮族の身体］［未熟な翼］［切り裂く風］'],
  ['0016', 'ウィークリング（タンノズ）', '［蛮族の身体］［水中適性］［甲殻の手］'],
  ['0016', 'ウィークリング（バジリスク）', '［蛮族の身体］［石化の視線］［毒の血液］'],
  ['0016', 'ウィークリング（ミノタウロス）', '［蛮族の身体］［暗視］［剛力］'],
  ['0016', 'ウィークリング（マーマン）', '［蛮族の身体］［水中適性］［水・氷耐性］', '［バブルフォーム］'],
  ['x001', 'フィー', '［妖精の加護］［浮遊］'],
  ['x002', 'フロウライト', '［魂の輝き］［鉱石の生命］［晶石の身体］'],
  ['x003', 'ハイマン', '［魔法の申し子］［デジャヴ］'],
  ['x004', 'ミアキス', '［暗視］［猫変化］［獣性の発露］'],
  ['x005', 'ヴァルキリー', '［戦乙女の光羽］［戦乙女の祝福］'],
  ['x006', 'センティアン（ルミエル）',   '［刻まれし聖印］［神の恩寵］［神の御名と共に］'],
  ['x006', 'センティアン（イグニス）',   '［刻まれし聖印］［暗視］［神の兵士］［神への礼賛］'],
  ['x006', 'センティアン（カルディア）', '［刻まれし聖印］［神の庇護］［神への祈り］'],
  ['x101', 'ノーブルエルフ', '［暗視］［剣の加護／水の申し子］［カリスマ］［痛みに弱い］'],
  ['x102', 'マナフレア', '［溢れるマナ］［マナの手］'],
  ['x201', '魔動天使', '［暗視］［造られし強さ］［鋼鉄の翼］［契約の絆］'],
  ['xa01', 'ダークドワーフ', '［暗視］［黒炎の遣い手］'],
  ['xb01', 'ドレイク（ナイト）', '［暗視］［魔剣の所持］［飛行（飛翔）］［竜化］'],
  ['xb02', 'ドレイク（ブロークン）', '［暗視］［限定竜化］'],
  ['xb03', 'バジリスク', '［邪視と瞳石］［猛毒の血液］［魔物化］'],
  ['xb04', 'リザードマン', '［尻尾が武器］［水中活動］［無呼吸活動］', ['［仲間との連携］','［敵への憤怒］'], ['［仲間との連携］','［敵への憤怒］'], ['［仲間との連携］','［敵への憤怒］'] ],
  ['xb05', 'ケンタウロス', '［半馬半人］［馬人の武術］'],
  ['xb06', 'ダークトロール', '［暗視］［弱体化］［トロールの体躯］', '［限定再生］'],
  ['xb07', 'ラミア', '［暗視］［ラミアの身体］［ラミアの吸血］［変化］'],
  ['xb08', 'ライカンスロープ', '［暗視］［獣人の力］［獣化］'],
  ['xb09', 'コボルド', '［種の限界］［軽視］［小さな匠］'],
  ['xb11', 'ラルヴァ', '［暗視］［吸血の祝福］［忌むべき血］［弱体化］'],
  ['xb12', 'バルカン', '［暗視］［炎無効］［バルカンの宝石］', '［強制召喚］'],
);

our @race_names;
our %race_ability;
our %race_ability_lv6;
our %race_ability_lv11;
our %race_ability_lv16;
foreach (@races){
  push (@race_names, @$_[1]);
  $race_ability{@$_[1]} = @$_[2];
  $race_ability_lv6{ @$_[1]} = @$_[3];
  $race_ability_lv11{@$_[1]} = @$_[4];
  $race_ability_lv16{@$_[1]} = @$_[5];
}

## ●種族ごとの言語
 # '種族名' => [
 #   [ '言語名' , 会話, 読文 ], 習得＝1　会話／読文なし＝0　未習得＝2
 # ],
our %race_language = (
  '人間' => [
    [ '交易共通語', 1, 1 ],
  ],
  'エルフ' => [
    [ '交易共通語', 1, 1 ],
    [ 'エルフ語', 1, 1 ],
  ],
  'ドワーフ' => [
    [ '交易共通語', 1, 1 ],
    [ 'ドワーフ語', 1, 1 ],
  ],
  'タビット' => [
    [ '交易共通語', 1, 1 ],
    [ '神紀文明語', 0, 1 ],
  ],
  'ルーンフォーク' => [
    [ '交易共通語', 1, 1 ],
    [ '魔動機文明語', 1, 1 ],
  ],
  'ナイトメア（人間）' => [
    [ '交易共通語', 1, 1 ],
  ],
  'ナイトメア（エルフ）' => [
    [ '交易共通語', 1, 1 ],
    [ 'エルフ語', 1, 1 ],
  ],
  'ナイトメア（ドワーフ）' => [
    [ '交易共通語', 1, 1 ],
    [ 'ドワーフ語', 1, 1 ],
  ],
  'ナイトメア（リルドラケン）' => [
    [ '交易共通語', 1, 1 ],
    [ 'ドラゴン語', 1, 0 ],
  ],
  'リカント' => [
    [ '交易共通語', 1, 1 ],
    [ 'リカント語', 1, 1 ],
  ],
  'リルドラケン' => [
    [ '交易共通語', 1, 1 ],
    [ 'ドラゴン語', 1, 0 ],
  ],
  'グラスランナー' => [
    [ '交易共通語', 1, 1 ],
    [ 'グラスランナー語', 1, 1 ],
  ],
  'メリア' => [
    [ '交易共通語', 1, 1 ],
    [ '妖精語', 1, 0 ],
  ],
  'ティエンス' => [
    [ '交易共通語', 1, 1 ],
    [ '魔神語', 1, 0 ],
  ],
  'アルヴ' => [
    [ '交易共通語', 1, 1 ],
  ],
  'シャドウ' => [
    [ '交易共通語', 1, 1 ],
    [ 'シャドウ語', 1, 1 ],
  ],
  'フィー' => [
    [ '交易共通語', 1, 1 ],
    [ '妖精語', 1, 0 ],
  ],
  'フロウライト' => [
    [ '交易共通語', 1, 1 ],
  ],
  'ハイマン' => [
    [ '交易共通語', 1, 1 ],
    [ '魔法文明語', 1, 1 ],
  ],
  'ミアキス' => [
    [ '交易共通語', 1, 1 ],
    [ 'ミアキス語', 1, 0 ],
  ],
  'ヴァルキリー' => [
    [ '交易共通語', 1, 1 ],
  ],
  'ソレイユ' => [
    [ '交易共通語', 1, 1 ],
    [ 'ソレイユ語', 1, 0 ],
  ],
  'レプラカーン' => [
    [ '交易共通語', 1, 1 ],
    [ '魔動機文明語', 1, 1 ],
  ],
  'センティアン（ルミエル）' => [
    [ '神紀文明語', 0, 1 ],
  ],
  'センティアン（イグニス）' => [
    [ '神紀文明語', 0, 1 ],
  ],
  'センティアン（カルディア）' => [
    [ '神紀文明語', 0, 1 ],
  ],
  'ノーブルエルフ' => [
    [ 'エルフ語', 1, 1 ],
    [ '魔法文明語', 1, 1 ],
  ],
  'マナフレア' => [
    [ '魔法文明語', 1, 1 ],
  ],
  '魔動天使' => [
    [ '交易共通語', 1, 1 ],
    [ '魔動機文明語', 1, 1 ],
  ],
  'ダークドワーフ' => [
    [ '交易共通語', 1, 1 ],
    [ 'ドワーフ語', 1, 1 ],
    [ '汎用蛮族語', 1, 1 ],
  ],
  'ドレイク（ナイト）' => [
    [ '交易共通語', 1, 1 ],
    [ '汎用蛮族語', 1, 1 ],
    [ 'ドレイク語', 1, 1 ],
  ],
  'ドレイク（ブロークン）' => [
    [ '交易共通語', 1, 1 ],
    [ '汎用蛮族語', 1, 1 ],
    [ 'ドレイク語', 1, 1 ],
  ],
  'バジリスク' => [
    [ '交易共通語', 1, 1 ],
    [ '汎用蛮族語', 1, 1 ],
    [ 'バジリスク語', 1, 1 ],
    [ 'ドレイク語', 1, 1 ],
    [ '妖魔語', 1, 0 ],
  ],
  'リザードマン' => [
    [ '汎用蛮族語', 1, 1 ],
    [ 'リザードマン語', 1, 1 ],
    [ 'ドラゴン語', 1, 0 ],
  ],
  'ケンタウロス' => [
    [ '汎用蛮族語', 1, 1 ],
    [ 'ケンタウロス語', 1, 1 ],
  ],
  'ダークトロール' => [
    [ '汎用蛮族語', 1, 1 ],
    [ '巨人語', 1, 1 ],
  ],
  'ラミア' => [
    [ '交易共通語', 1, 1 ],
    [ '汎用蛮族語', 1, 1 ],
    [ 'ドレイク語', 1, 1 ],
  ],
  'ライカンスロープ' => [
    [ '交易共通語', 1, 1 ],
    [ '汎用蛮族語', 1, 1 ],
    [ 'ライカンスロープ語', 1, 1 ],
  ],
  'コボルド' => [
    [ '交易共通語', 1, 1 ],
    [ '汎用蛮族語', 1, 1 ],
    [ '妖魔語', 1, 0 ],
  ],
  'ウィークリング（ガルーダ）' => [
    [ '交易共通語', 1, 1 ],
    [ '汎用蛮族語', 1, 1 ],
  ],
  'ウィークリング（タンノズ）' => [
    [ '交易共通語', 1, 1 ],
    [ '汎用蛮族語', 1, 1 ],
  ],
  'ウィークリング（バジリスク）' => [
    [ '交易共通語', 1, 1 ],
    [ '汎用蛮族語', 1, 1 ],
  ],
  'ウィークリング（マーマン）' => [
    [ '交易共通語', 1, 1 ],
    [ '汎用蛮族語', 1, 1 ],
  ],
  'ウィークリング（ミノタウロス）' => [
    [ '交易共通語', 1, 1 ],
    [ '汎用蛮族語', 1, 1 ],
  ],
  'ラルヴァ' => [
    [ '交易共通語', 1, 1 ],
  ],
  'バルカン' => [
    [ '汎用蛮族語', 1, 1 ],
    [ 'バルカン語', 1, 1 ],
  ],
);

our %race_dices = (
  '人間' => {
    'A' => 2, 'B' => 2, 'C' => 2, 'D' => 2, 'E' => 2, 'F' => 2,
  },
  'エルフ' => {
    'A' => 2, 'B' => 2, 'C' => 1, 'D' => 2, 'E' => 2, 'F' => 2,
  },
  'ドワーフ' => {
    'A' => 2, 'B' => 1, 'C' => 2, 'D' => 2, 'E' => 1, 'F' => 2,
    'A+'=> 6,                                         'F+'=> 6,
  },
  'タビット' => {
    'A' => 1, 'B' => 1, 'C' => 1, 'D' => 2, 'E' => 2, 'F' => 2,
                                            'E+'=> 6,
  },
  'ルーンフォーク' => {
    'A' => 2, 'B' => 1, 'C' => 2, 'D' => 2, 'E' => 2, 'F' => 1,
  },
  'ナイトメア' => {
    'A' => 2, 'B' => 2, 'C' => 1, 'D' => 1, 'E' => 2, 'F' => 2,
  },
  'リカント' => {
    'A' => 1, 'B' => 1, 'C' => 2, 'D' => 2, 'E' => 1, 'F' => 1,
              'B+'=> 3,                     'E+'=> 6, 
  },
  'リルドラケン' => {
    'A' => 1, 'B' => 2, 'C' => 2, 'D' => 2, 'E' => 1, 'F' => 2,
                                  'D+'=> 6,
  },
  'グラスランナー' => {
    'A' => 2, 'B' => 2, 'C' => 1, 'D' => 2, 'E' => 1, 'F' => 2,
                                  'D+'=> 6,           'F+'=> 6,
  },
  'メリア' => {
    'A' => 1, 'B' => 1, 'C' => 1, 'D' => 2, 'E' => 1, 'F' => 1,
                                  'D+'=> 6,
  },
  'ティエンス' => {
    'A' => 2, 'B' => 2, 'C' => 1, 'D' => 1, 'E' => 2, 'F' => 2,
                                  'D+'=> 3,           'F+'=> 3,
  },
  'レプラカーン' => {
    'A' => 2, 'B' => 1, 'C' => 2, 'D' => 2, 'E' => 2, 'F' => 2,
  },
  'アルヴ' => {
    'A' => 1, 'B' => 1, 'C' => 2, 'D' => 2, 'E' => 1, 'F' => 1,
              'B+'=> 3, 'C+'=> 3,           'E+'=> 6,
  },
  'シャドウ' => {
    'A' => 1, 'B' => 1, 'C' => 2, 'D' => 2, 'E' => 2, 'F' => 2,
  },
  'フィー' => {
    'A' => 2, 'B' => 2, 'C' => 1, 'D' => 1, 'E' => 1, 'F' => 2,
              'B+'=> 6,
  },
  'フロウライト' => {
    'A' => 2, 'B' => 2, 'C' => 2, 'D' => 2, 'E' => 1, 'F' => 2,
                        'C+'=> 6,                     'F+'=> 6,
  },
  'ハイマン' => {
    'A' => 2, 'B' => 1, 'C' => 2, 'D' => 1, 'E' => 1, 'F' => 1,
  },
  'ミアキス' => {
    'A' => 1, 'B' => 2, 'C' => 1, 'D' => 2, 'E' => 2, 'F' => 2,
                                            'E+'=> 6,
  },
  'ヴァルキリー' => {
    'A' => 2, 'B' => 1, 'C' => 2, 'D' => 2, 'E' => 1, 'F' => 1,
                                                      'F+'=> 6,
  },
  'ソレイユ' => {
    'A' => 1, 'B' => 2, 'C' => 1, 'D' => 2, 'E' => 1, 'F' => 2,
                        'C+'=> 6,
  },
  'センティアン（ルミエル）' => {
    'A' => 1, 'B' => 2, 'C' => 1, 'D' => 2, 'E' => 2, 'F' => 2,
  },
  'センティアン（イグニス）' => {
    'A' => 1, 'B' => 2, 'C' => 2, 'D' => 1, 'E' => 2, 'F' => 2,
                                  'D+'=> 6,
  },
  'センティアン（カルディア）' => {
    'A' => 1, 'B' => 2, 'C' => 1, 'D' => 1, 'E' => 1, 'F' => 1,
                                            'E+'=> 6, 'F+'=> 6,
  },
  'ノーブルエルフ' => {
    'A' => 2, 'B' => 2, 'C' => 1, 'D' => 2, 'E' => 2, 'F' => 2,
  },
  'マナフレア' => {
    'A' => 2, 'B' => 1, 'C' => 2, 'D' => 2, 'E' => 2, 'F' => 1,
              'B+'=> 6, 'C+'=> 6,                     'F+'=> 6,
  },
  'ダークドワーフ' => {
    'A' => 2, 'B' => 1, 'C' => 2, 'D' => 1, 'E' => 1, 'F' => 2,
    'A+'=> 6,                                         'F+'=> 6,
  },
  'ドレイク（ブロークン）' => {
    'A' => 1, 'B' => 1, 'C' => 2, 'D' => 2, 'E' => 2, 'F' => 2,
                                            'E+'=> 6,
  },
  'ドレイク（ナイト）' => {
    'A' => 1, 'B' => 1, 'C' => 2, 'D' => 2, 'E' => 2, 'F' => 2,
                                            'E+'=> 6,
  },
  'バジリスク' => {
    'A' => 1, 'B' => 2, 'C' => 2, 'D' => 2, 'E' => 1, 'F' => 1,
    'A+'=> 6,
  },
  'リザードマン' => {
    'A' => 1, 'B' => 2, 'C' => 2, 'D' => 2, 'E' => 2, 'F' => 1,
  },
  'ケンタウロス' => {
    'A' => 2, 'B' => 1, 'C' => 2, 'D' => 2, 'E' => 1, 'F' => 2,
    'A+'=> 6,
  },
  'ダークトロール' => {
    'A' => 2, 'B' => 1, 'C' => 2, 'D' => 2, 'E' => 1, 'F' => 2,
                                  'D+'=> 6,
  },
  'ラミア' => {
    'A' => 1, 'B' => 2, 'C' => 1, 'D' => 2, 'E' => 2, 'F' => 2,
  },
  'ライカンスロープ' => {
    'A' => 2, 'B' => 2, 'C' => 2, 'D' => 2, 'E' => 2, 'F' => 2,
                                  'D+'=> 6,
  },
  'コボルド' => {
    'A' => 2, 'B' => 2, 'C' => 1, 'D' => 1, 'E' => 2, 'F' => 2,
  },
  'ウィークリング' => {
    'A' => 2, 'B' => 2, 'C' => 2, 'D' => 2, 'E' => 2, 'F' => 2,
  },
  'ラルヴァ' => {
    'A' => 1, 'B' => 2, 'C' => 2, 'D' => 1, 'E' => 2, 'F' => 1,
                        'C+'=> 6,
  },
  'バルカン' => {
    'A' => 2, 'B' => 1, 'C' => 2, 'D' => 2, 'E' => 2, 'F' => 1,
                                  'D+'=> 6,
  }
);


1;